package br.com.estruturadedados.usalocadora.locadora;

import br.com.estruturadedados.usalocadora.locadora.itens.Disco;
import br.com.estruturadedados.usalocadora.locadora.itens.Filme;
import br.com.estruturadedados.usalocadora.locadora.itens.Item;
import br.com.estruturadedados.utilitario.lista.Lista;
import br.com.estruturadedados.utilitario.lista.encadeada.duplamente.ListaDuplamenteEncadeada;

public class Locadora {

    private Lista<Item> discos;
    private Lista<Item> filmes;
    private int indiceD;
    private int indiceF;

    public Locadora() {
        this.indiceD = 0;
        this.discos = new ListaDuplamenteEncadeada<>();
        this.indiceF = 0;
        this.filmes = new ListaDuplamenteEncadeada<>();
    }

    public void novoDisco(Disco d) {
        if (this.indiceD < 2) {
            this.discos.adicionaFim(d);
            this.indiceD += 1;
        }
    }

    public void novoFilme(Filme f) {
        if (this.indiceF < 2) {
            this.filmes.adicionaFim(f);
            this.indiceF += 1;
        }
    }

    public void ListaDeDiscos() {
        int i = 0;
        for (Item item : this.discos) {
            try {
                System.out.println("Informações do disco " + i + ": ");
                System.out.println("-----------------------------------------");
                ((Disco) item).ListaInformacoes();
                System.out.println("-----------------------------------------" + "\n");
                i++;
            } catch (Exception ex) {
                System.out.println(ex.getMessage());
            }
        }
    }

    public void ListaDeFilmes() {
        int i = 0;
        for (Item item : this.filmes) {
            try {
                System.out.println("Informações do filme " + i + ": ");
                System.out.println("-----------------------------------------");
                ((Filme) item).ListaInformacoes();
                System.out.println("-----------------------------------------" + "\n");
                i++;
            } catch (Exception ex) {
                System.out.println(ex.getMessage());
            }
        }
    }

    public int getIndiceD() {
        return this.indiceD;
    }

    public void setIndiceD(int indiceD) {
        this.indiceD = indiceD;
    }

    public int getIndiceF() {
        return this.indiceF;
    }

    public void setIndiceF(int indiceF) {
        this.indiceF = indiceF;
    }

    public Lista<Item> getDiscos() {
        return this.discos;
    }

    public Lista<Item> getFilmes() {
        return this.filmes;
    }

}
