package br.com.estruturadedados.usalocadora.locadora.itens;

public abstract class Item implements Comparable<Item> {

    private String titulo;
    private int anoDeLancamento;
    private String comentario;

    public Item(String titulo, int anoDeLancamento, String comentario) {
        this.titulo = titulo;
        this.anoDeLancamento = anoDeLancamento;
        this.comentario = comentario;
    }

    public abstract void ListaInformacoes();

    public String getTitulo() {
        return this.titulo;
    }

    public void setTitulo(String titulo) {
        this.titulo = titulo;
    }

    public int getAnoDeLancamento() {
        return this.anoDeLancamento;
    }

    public void setAnoDeLancamento(int anoDeLancamento) {
        this.anoDeLancamento = anoDeLancamento;
    }

    public String getComentario() {
        return this.comentario;
    }

    public void setComentario(String comentario) {
        this.comentario = comentario;
    }

    @Override
    public int compareTo(Item item) {
        int compareToTitulo = this.titulo.compareToIgnoreCase(item.titulo);
        int compareToAnoDeLancamento = ((Integer) this.anoDeLancamento).compareTo((Integer) item.anoDeLancamento);
        int compareToComentario = this.comentario.compareToIgnoreCase(item.comentario);
        if (compareToTitulo < 0 && compareToAnoDeLancamento < 0 && compareToComentario < 0) {
            return -1;
        } else {
            if (compareToTitulo == 0 && compareToAnoDeLancamento == 0 && compareToComentario == 0) {
                return 0;
            }
        }
        return 1;
    }
}
