package br.com.estruturadedados.utilitario.colecao;

public interface Colecao<E extends Comparable<E>> extends Iterable<E> {

    public void adiciona(E elemento, int posicao) throws Exception;

    public void adicionaInicio(E elemento);

    public void adicionaFim(E elemento);

    public E recupera(int posicao) throws Exception;

    public boolean vazio();

    public void remove(int posicao) throws Exception;

    public void removeInicio() throws Exception;

    public void removeFim() throws Exception;

    public int tamanho();

    public void limpa() throws Exception;

    @Override
    public Iterator<E> iterator();

}
