package br.com.estruturadedados.utilitario.lista;

import br.com.estruturadedados.utilitario.colecao.Colecao;
import br.com.estruturadedados.utilitario.colecao.Iterator;

public interface Lista<E extends Comparable<E>> extends Colecao<E> {

    @Override
    public void adiciona(E elemento, int posicao) throws Exception;

    @Override
    public void adicionaInicio(E elemento);

    @Override
    public void adicionaFim(E elemento);

    @Override
    public E recupera(int posicao) throws Exception;

    @Override
    public boolean vazio();

    @Override
    public void remove(int posicao) throws Exception;

    @Override
    public void removeInicio() throws Exception;

    @Override
    public void removeFim() throws Exception;

    @Override
    public int tamanho();

    @Override
    public void limpa() throws Exception;

    @Override
    public Iterator<E> iterator();

}
