package br.com.estruturadedados.utilitario.lista.vetor;

import br.com.estruturadedados.utilitario.colecao.Iterator;

public class Iterador<E> implements Iterator<E> {

    private E[] elementos;
    private int posicao;
    private int tamanho;
    private E elemento;

    public Iterador(E[] elementos) {
        this.elementos = elementos;
        this.posicao = 0;
        this.tamanho = this.elementos.length;
        this.elemento = null;
    }

    @Override
    public boolean hasNext() {
        boolean hasNext = false;
        if (this.posicao < this.tamanho) {
            hasNext = this.elementos[this.posicao] != null;
        }
        return hasNext;
    }

    @Override
    public boolean hasPrevious() {
        boolean hasPrevious = false;
        if (this.posicao > 0) {
            hasPrevious = this.elementos[this.posicao] != null;
        }
        return hasPrevious;
    }

    @Override
    public E next() {
        this.elemento = this.elementos[this.posicao];
        this.posicao += 1;
        return this.elemento;
    }

    @Override
    public E previous() {
        this.elemento = this.elementos[this.posicao];
        this.posicao -= 1;
        return this.elemento;
    }
}
