package br.com.estruturadedados.utilitario.ordenador;

import br.com.estruturadedados.utilitario.lista.Lista;
import br.com.estruturadedados.utilitario.lista.vetor.ListaVetor;

public class OrdenadorListaVetor<E extends Comparable<E>> implements Ordenador<E> {

    private ListaVetor<E> lista;
    private E[] elementos;
    private int tamanho;

    public OrdenadorListaVetor(Lista<E> lista) {
        this.lista = (ListaVetor<E>) lista;
        this.elementos = this.lista.getElementos();
        this.tamanho = this.lista.tamanho();
    }

    @Override
    public void bubbleSort() {
        for (int i = 0; i < this.tamanho; i++) {
            for (int j = 0; j < (this.tamanho - 1); j++) {
                if (this.elementos[j].compareTo(this.elementos[(j + 1)]) == 1) {
                    E elementoTemporario = this.elementos[j];
                    this.elementos[j] = this.elementos[(j + 1)];
                    this.elementos[(j + 1)] = elementoTemporario;
                }
            }
        }
        this.lista.setElementos(this.elementos);
    }

    @Override
    public void insertionSort() {
        for (int i = 1; i < this.tamanho; i++) {
            E elementoTemporario = this.elementos[i];
            int j = i - 1;
            while (j >= 0 && this.elementos[j].compareTo(elementoTemporario) == 1) {
                this.elementos[(j + 1)] = this.elementos[j];
                j -= 1;
            }
            this.elementos[(j + 1)] = elementoTemporario;
        }
        this.lista.setElementos(this.elementos);
    }

    @Override
    public void selectionSort() {
        for (int i = 0; i < this.tamanho; i++) {
            int menor = i;
            for (int j = (i + 1); j < this.tamanho; j++) {
                if (this.elementos[j].compareTo(this.elementos[menor]) == -1) {
                    menor = j;
                }
            }
            E elementoTemporario = this.elementos[i];
            this.elementos[i] = this.elementos[menor];
            this.elementos[menor] = elementoTemporario;
        }
        this.lista.setElementos(this.elementos);
    }

    @Override
    public void quickSort() {
        this.quickSort(this.elementos, 0, this.tamanho - 1);
    }

    private void quickSort(E[] elementos, int esquerda, int direita) {
        int esq = esquerda;
        int dir = direita;
        E pivo = elementos[(esq + dir) / 2];
        E troca;
        while (esq <= dir) {
            while (elementos[esq].compareTo(pivo) == -1) {
                esq = esq + 1;
            }
            while (elementos[dir].compareTo(pivo) == 1) {
                dir = dir - 1;
            }
            if (esq <= dir) {
                troca = elementos[esq];
                elementos[esq] = elementos[dir];
                elementos[dir] = troca;
                esq = esq + 1;
                dir = dir - 1;
            }
        }
        if (dir > esquerda) {
            quickSort(elementos, esquerda, dir);
        }
        if (esq < direita) {
            quickSort(elementos, esq, direita);
        }
    }

    @Override
    public void mergeSort() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void shellSort() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void reapSort() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void radixSort() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

}
